#version 150

out vec4 gl_FragColor;
in vec2 texcoord;

uniform sampler2D source;
uniform int mode;

void main(void){

   if(mode == 1){
      gl_FragColor = noise4(texcoord);
   }

   float neighbour = 0;
   vec2 offset = 1.0 / textureSize(source, 0);

   if(texture(source, texcoord - vec2(offset.x,offset.y))   != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(offset.x,0.0))      != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(offset.x,-offset.y))  != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(0.0,-offset.y))     != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(-offset.x,-offset.y)) != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(-offset.x,0.0))     != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(-offset.x,offset.y))  != vec4(0.0)) neighbour++;
   if(texture(source, texcoord - vec2(0.0,offset.y))      != vec4(0.0)) neighbour++;

   if(neighbour < 2 && neighbour > 3) gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
   else gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
}
