
typedef struct _VertexVector {
   float dx;
   float dy;
   float dz;
   float weight;
   unsigned int index; /* Index in the vertex buffer object */
} VertexVector;

typedef struct _Bone {
   float headx;
   float heady;
   float headz;
   float tailx;
   float taily;
   float tailz;

   unsigned int vertnum;
   VertexVector *verts;
}Bone;

Bone *createBone(float hx, float hy, float hz, float tx, float ty, float tz);
void deleteBone(Bone *b);
int addVertex(Bone *b, VertexVector v);
void fillBoneVertex(Bone *b, float *vbo);
void recalculateVertex(Bone *b, float *vbo, float matrix[16]);
void loadVertexWeight(Bone *b, const char *filename);
